Index: squid/src/store_swapout.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_swapout.c,v
retrieving revision 1.1.1.3.10.5.2.1
retrieving revision 1.1.1.3.10.5.2.2
diff -u -r1.1.1.3.10.5.2.1 -r1.1.1.3.10.5.2.2
--- squid/src/store_swapout.c	8 May 2000 18:02:08 -0000	1.1.1.3.10.5.2.1
+++ squid/src/store_swapout.c	14 May 2000 23:22:20 -0000	1.1.1.3.10.5.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_swapout.c,v 1.1.1.3.10.5.2.1 2000/05/08 18:02:08 hno Exp $
+ * $Id: store_swapout.c,v 1.1.1.3.10.5.2.2 2000/05/14 23:22:20 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Swapout Functions
  * AUTHOR: Duane Wessels
@@ -71,8 +71,8 @@
 	xfree(buf);
 	return;
     }
-    storeLockObject(e); /* Don't lock until after create, or the replacement
-                         * code might get confused */
+    storeLockObject(e);		/* Don't lock until after create, or the replacement
+				 * code might get confused */
     /* Pick up the file number if it was assigned immediately */
     e->swap_filen = mem->swapout.sio->swap_filen;
     e->swap_dirn = mem->swapout.sio->swap_dirn;
@@ -134,8 +134,8 @@
      */
     swapout_size = (size_t) (mem->inmem_hi - mem->swapout.queue_offset);
     if ((e->store_status != STORE_OK) && (swapout_size < store_maxobjsize)) {
-        debug (20, 5) ("storeSwapOut: Deferring starting swapping out\n"); 
-        return;
+	debug(20, 5) ("storeSwapOut: Deferring starting swapping out\n");
+	return;
     }
     /*
      * Careful.  lowest_offset can be greater than inmem_hi, such
@@ -194,8 +194,8 @@
      * than the maximum object size (so we pick a -1 maxobjsize fs)
      */
     if ((e->store_status != STORE_OK) && (swapout_size < store_maxobjsize)) {
-        debug (20, 5) ("storeSwapOut: Deferring starting swapping out\n"); 
-        return;
+	debug(20, 5) ("storeSwapOut: Deferring starting swapping out\n");
+	return;
     }
     /* Ok, we have stuff to swap out.  Is there a swapout.sio open? */
     if (e->swap_status == SWAPOUT_NONE) {
@@ -210,18 +210,18 @@
     if (NULL == mem->swapout.sio)
 	return;
     do {
-        /*
+	/*
 	 * Evil hack time.
 	 * We are paging out to disk in page size chunks. however, later on when
 	 * we update the queue position, we might not have a page (I *think*),
 	 * so we do the actual page update here.
-         */
+	 */
 
-        if (mem->swapout.memnode == NULL) {
-            /* We need to swap out the first page */
+	if (mem->swapout.memnode == NULL) {
+	    /* We need to swap out the first page */
 	    mem->swapout.memnode = mem->data_hdr.head;
 	} else {
-            /* We need to swap out the next page */
+	    /* We need to swap out the next page */
 	    mem->swapout.memnode = mem->swapout.memnode->next;
 	}
 	/*
@@ -292,8 +292,8 @@
 	}
 	if (e->swap_filen > 0)
 	    storeUnlink(e);
-        e->swap_filen = -1;
-        e->swap_dirn = -1;
+	e->swap_filen = -1;
+	e->swap_dirn = -1;
 	e->swap_status = SWAPOUT_NONE;
 	storeReleaseRequest(e);
     } else {
@@ -356,8 +356,8 @@
      * even if its not cachable
      */
     for (node = e->mem_obj->clients.head; node; node = node->next) {
-        if (((store_client *)node->data)->type == STORE_DISK_CLIENT)
-            return 1;
+	if (((store_client *) node->data)->type == STORE_DISK_CLIENT)
+	    return 1;
     }
     if (store_dirs_rebuilding)
 	if (!EBIT_TEST(e->flags, ENTRY_SPECIAL))
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.1.1.3.10.8.2.5
retrieving revision 1.1.1.3.10.8.2.6
diff -u -r1.1.1.3.10.8.2.5 -r1.1.1.3.10.8.2.6
--- squid/src/structs.h	8 May 2000 18:02:08 -0000	1.1.1.3.10.8.2.5
+++ squid/src/structs.h	14 May 2000 23:22:20 -0000	1.1.1.3.10.8.2.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.1.1.3.10.8.2.5 2000/05/08 18:02:08 hno Exp $
+ * $Id: structs.h,v 1.1.1.3.10.8.2.6 2000/05/14 23:22:20 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -210,6 +210,11 @@
 
 #endif
 
+struct _RemovalPolicySettings {
+    char *type;
+    wordlist *args;
+};
+
 struct _SquidConfig {
     struct {
 	size_t maxSize;
@@ -227,14 +232,8 @@
 	int pct;
 	size_t max;
     } quickAbort;
-#if HEAP_REPLACEMENT
-    char *replPolicy;
-#else
-    /* 
-     * Note: the non-LRU policies do not use referenceAge, but we cannot
-     * remove it until we find out how to implement #else for cf_parser.c
-     */
-#endif
+    RemovalPolicySettings *replPolicy;
+    RemovalPolicySettings *memPolicy;
     time_t referenceAge;
     time_t negativeTtl;
     time_t negativeDnsTtl;
@@ -494,12 +493,6 @@
 	int rebuild_chunk_percentage;
     } digest;
 #endif
-#if USE_DISKD
-    struct {
-	int magic1;
-	int magic2;
-    } diskd;
-#endif
 };
 
 struct _SquidConfig2 {
@@ -861,6 +854,7 @@
     ConnStateData *conn;
     request_t *request;		/* Parsed URL ... */
     store_client *sc;		/* The store_client we're using */
+    store_client *old_sc;	/* ... for entry to be validated */
     char *uri;
     char *log_uri;
     struct {
@@ -1225,6 +1219,7 @@
     int psize;
     char payload[PINGER_PAYLOAD_SZ];
 };
+
 #endif
 
 struct _icp_common_t {
@@ -1282,6 +1277,39 @@
 };
 
 
+/* Removal policies */
+
+struct _RemovalPolicyNode {
+    void *data;
+};
+
+struct _RemovalPolicy {
+    char *_type;
+    void *_data;
+    void (*Free)(RemovalPolicy *policy);
+    void (*Add)(RemovalPolicy *policy, StoreEntry *entry, RemovalPolicyNode *node);
+    void (*Remove)(RemovalPolicy *policy, StoreEntry *entry, RemovalPolicyNode *node);
+    void (*Referenced)(RemovalPolicy *policy, const StoreEntry *entry, RemovalPolicyNode *node);
+    void (*Dereferenced)(RemovalPolicy *policy, const StoreEntry *entry, RemovalPolicyNode *node);
+    RemovalPolicyWalker *(*WalkInit)(RemovalPolicy *policy);
+    RemovalPurgeWalker *(*PurgeInit)(RemovalPolicy *policy, int max_scan);
+};
+
+struct _RemovalPolicyWalker {
+    RemovalPolicy *_policy;
+    void *_data;
+    const StoreEntry *(*Next)(RemovalPolicyWalker *walker);
+    void (*Done)(RemovalPolicyWalker *walker);
+};
+
+struct _RemovalPurgeWalker {
+    RemovalPolicy *_policy;
+    void *_data;
+    int scanned, max_scan, locked;
+    StoreEntry *(*Next)(RemovalPurgeWalker *walker);
+    void (*Done)(RemovalPurgeWalker *walker);
+};
+
 /* This structure can be freed while object is purged out from memory */
 struct _MemObject {
     method_t method;
@@ -1293,7 +1321,7 @@
     int nclients;
     struct {
 	off_t queue_offset;	/* relative to in-mem data */
-        mem_node *memnode;	/* which node we're currently paging out */
+	mem_node *memnode;	/* which node we're currently paging out */
 	storeIOState *sio;
     } swapout;
     HttpReply *reply;
@@ -1307,14 +1335,7 @@
 	void *data;
     } abort;
     char *log_url;
-#if HEAP_REPLACEMENT
-    /* 
-     * A MemObject knows where it is in the in-memory heap.
-     */
-    heap_node *node;
-#else
-    dlink_node lru;
-#endif
+    RemovalPolicyNode repl;
     int id;
     ssize_t object_sz;
     size_t swap_hdr_sz;
@@ -1337,12 +1358,7 @@
     u_short flags;
     sdirno swap_dirn;
     sfileno swap_filen;
-    union {
-#ifdef HEAP_REPLACEMENT
-        heap_node *node;
-#endif
-        dlink_node lru;
-    } repl;
+    RemovalPolicyNode repl;
     u_short lock_count;		/* Assume < 65536! */
     mem_status_t mem_status:3;
     ping_status_t ping_status:3;
@@ -1359,17 +1375,7 @@
     int index;			/* This entry's index into the swapDirs array */
     int suggest;
     size_t max_objsize;
-    union {
-#ifdef HEAP_REPLACEMENT
-        struct {
-	   heap *heap;
-	} heap;
-#endif
-        struct {
-	   dlink_list list;
-	   dlink_node *walker;
-	} lru;
-    } repl;
+    RemovalPolicy *repl;
     int removals;
     int scanned;
     struct {
@@ -1390,7 +1396,7 @@
     STCALLBACK *callback;	/* Handle pending callbacks */
     STSYNC *sync;		/* Sync the directory */
     struct {
-        STOBJCREATE *create;
+	STOBJCREATE *create;
 	STOBJOPEN *open;
 	STOBJCLOSE *close;
 	STOBJREAD *read;
@@ -1402,8 +1408,10 @@
 	STLOGCLOSE *close;
 	STLOGWRITE *write;
 	struct {
-	    STLOGCLEANOPEN *open;
+	    STLOGCLEANSTART *start;
+	    STLOGCLEANNEXTENTRY *nextentry;
 	    STLOGCLEANWRITE *write;
+	    STLOGCLEANDONE *done;
 	    void *state;
 	} clean;
     } log;
@@ -1905,7 +1913,7 @@
     int recv_count;		/* number of messages received */
     struct {
 	char *buf;		/* shm buffer */
-	link_list *stack;	
+	link_list *stack;
 	int id;			/* sysvshm id */
     } shm;
 };
@@ -1917,3 +1925,4 @@
     size_t bufsz;
     off_t offset;
 };
+
Index: squid/src/typedefs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/typedefs.h,v
retrieving revision 1.1.1.3.10.6.2.1
retrieving revision 1.1.1.3.10.6.2.2
diff -u -r1.1.1.3.10.6.2.1 -r1.1.1.3.10.6.2.2
--- squid/src/typedefs.h	2 May 2000 22:50:29 -0000	1.1.1.3.10.6.2.1
+++ squid/src/typedefs.h	14 May 2000 23:22:20 -0000	1.1.1.3.10.6.2.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: typedefs.h,v 1.1.1.3.10.6.2.1 2000/05/02 22:50:29 hno Exp $
+ * $Id: typedefs.h,v 1.1.1.3.10.6.2.2 2000/05/14 23:22:20 hno Exp $
  *
  *
  * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -171,6 +171,11 @@
 typedef struct _storefs_entry storefs_entry_t;
 typedef struct _diskd_queue diskd_queue;
 typedef struct _Logfile Logfile;
+typedef struct _RemovalPolicy RemovalPolicy;
+typedef struct _RemovalPolicyWalker RemovalPolicyWalker;
+typedef struct _RemovalPurgeWalker RemovalPurgeWalker;
+typedef struct _RemovalPolicyNode RemovalPolicyNode;
+typedef struct _RemovalPolicySettings RemovalPolicySettings;
 
 #if SQUID_SNMP
 typedef variable_list *(oid_ParseFn) (variable_list *, snint *);
@@ -195,11 +200,11 @@
 /* disk.c / diskd.c callback typedefs */
 typedef void DRCB(int, const char *buf, int size, int errflag, void *data);
 							/* Disk read CB */
-typedef void DWCB(int, int, size_t, void *);		/* disk write CB */
+typedef void DWCB(int, int, size_t, void *);	/* disk write CB */
 typedef void DOCB(int, int errflag, void *data);	/* disk open CB */
 typedef void DCCB(int, int errflag, void *data);	/* disk close CB */
-typedef void DUCB(int errflag, void *data);		/* disk unlink CB */
-typedef void DTCB(int errflag, void *data);		/* disk trunc CB */
+typedef void DUCB(int errflag, void *data);	/* disk unlink CB */
+typedef void DTCB(int errflag, void *data);	/* disk trunc CB */
 
 typedef void FQDNH(const char *, void *);
 typedef void IDCB(const char *ident, void *data);
@@ -251,8 +256,10 @@
 typedef void STLOGOPEN(SwapDir *);
 typedef void STLOGCLOSE(SwapDir *);
 typedef void STLOGWRITE(const SwapDir *, const StoreEntry *, int);
-typedef int STLOGCLEANOPEN(SwapDir *);
-typedef void STLOGCLEANWRITE(const StoreEntry *, SwapDir *);
+typedef int STLOGCLEANSTART(SwapDir *);
+typedef const StoreEntry *STLOGCLEANNEXTENTRY(SwapDir *);
+typedef void STLOGCLEANWRITE(SwapDir *, const StoreEntry *);
+typedef void STLOGCLEANDONE(SwapDir *);
 
 /* Store dir configuration routines */
 /* SwapDir *sd, char *path ( + char *opt later when the strtok mess is gone) */
@@ -301,4 +308,5 @@
 typedef struct _htcpReplyData htcpReplyData;
 #endif
 
+typedef RemovalPolicy *REMOVALPOLICYCREATE(wordlist *args);
 #endif /* _TYPEDEFS_H_ */
Index: squid/src/url.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/url.c,v
retrieving revision 1.1.1.3.10.2
retrieving revision 1.1.1.3.10.2.2.1
diff -u -r1.1.1.3.10.2 -r1.1.1.3.10.2.2.1
--- squid/src/url.c	20 Apr 2000 18:14:23 -0000	1.1.1.3.10.2
+++ squid/src/url.c	14 May 2000 23:22:20 -0000	1.1.1.3.10.2.2.1
@@ -1,6 +1,6 @@
 
 /*
- * $Id: url.c,v 1.1.1.3.10.2 2000/04/20 18:14:23 hno Exp $
+ * $Id: url.c,v 1.1.1.3.10.2.2.1 2000/05/14 23:22:20 hno Exp $
  *
  * DEBUG: section 23    URL Parsing
  * AUTHOR: Duane Wessels
@@ -243,10 +243,10 @@
 	port = urlDefaultPort(protocol);
 	/* Is there any login informaiton? */
 	if ((t = strrchr(host, '@'))) {
-	    strcpy((char *)login, (char *)host);
+	    strcpy((char *) login, (char *) host);
 	    t = strrchr(login, '@');
 	    *t = 0;
-	    strcpy((char *)host, t + 1);
+	    strcpy((char *) host, t + 1);
 	}
 	if ((t = strrchr(host, ':'))) {
 	    *t++ = '\0';
